diff --git a/_ide_helper.php b/_ide_helper.php
index b307038..7f7a796 100644
--- a/_ide_helper.php
+++ b/_ide_helper.php
@@ -16561,3 +18107,5 @@ namespace {
 
 }
 
+
+
diff --git a/app/Exceptions/Handler.php b/app/Exceptions/Handler.php
index becf49e..d76d6eb 100644
--- a/app/Exceptions/Handler.php
+++ b/app/Exceptions/Handler.php
@@ -9,6 +9,7 @@ use Illuminate\Database\Eloquent\ModelNotFoundException;
 use Illuminate\Http\Exceptions\HttpResponseException;
 use Illuminate\Session\TokenMismatchException;
 use Illuminate\Validation\ValidationException;
+use Symfony\Component\HttpFoundation\Response;
 use Symfony\Component\HttpKernel\Exception\HttpException;
 use Illuminate\Foundation\Exceptions\Handler as ExceptionHandler;
 use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
@@ -52,7 +53,7 @@ class Handler extends ExceptionHandler
         if ($e instanceof HttpResponseException) {
             return $e->getResponse();
         } elseif ($e instanceof ModelNotFoundException) {
-            $e = new NotFoundHttpException($e->getMessage(), $e);
+            $e = new NotFoundHttpException("Resource not found.", $e);
         } elseif ($e instanceof AuthorizationException) {
             $e = new HttpException(403, $e->getMessage());
         } elseif ($e instanceof ValidationException && $e->getResponse()) {
@@ -62,6 +63,13 @@ class Handler extends ExceptionHandler
         }
 
         if ($this->isHttpException($e)) {
+            if ($request->expectsJson()) {
+                return response()->json(
+                    ['error' => $e->getMessage() ?: $this->getMessageFromStatusCode($e->getStatusCode())],
+                    $e->getStatusCode()
+                );
+            }
+
             return $this->toIlluminateResponse($this->renderHttpException($e), $e);
         }
 
@@ -85,4 +93,9 @@ class Handler extends ExceptionHandler
 
         return redirect()->guest('login');
     }
+
+    private function getMessageFromStatusCode($code)
+    {
+        return array_get(Response::$statusTexts, $code);
+    }
 }
diff --git a/app/Http/Controllers/Api/ActivityController.php b/app/Http/Controllers/Api/ActivityController.php
new file mode 100644
index 0000000..65a050e
--- /dev/null
+++ b/app/Http/Controllers/Api/ActivityController.php
@@ -0,0 +1,39 @@
+<?php
+
+namespace Portal\Http\Controllers\Api;
+
+use Portal\Http\Requests\Activity\GetActivitiesRequest;
+use Portal\Repositories\Activity\ActivityRepository;
+use Portal\Transformers\ActivityTransformer;
+
+/**
+ * Class ActivityController
+ * @package Portal\Http\Controllers\Api
+ */
+class ActivityController extends ApiController
+{
+    public function __construct()
+    {
+        $this->middleware('auth');
+        $this->middleware('permission:users.activity');
+    }
+
+    /**
+     * Paginate user activities.
+     * @param GetActivitiesRequest $request
+     * @param ActivityRepository $activities
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function index(GetActivitiesRequest $request, ActivityRepository $activities)
+    {
+        $result = $activities->paginateActivities(
+            $request->per_page ?: 20,
+            $request->search
+        );
+
+        return $this->respondWithPagination(
+            $result,
+            new ActivityTransformer
+        );
+    }
+}
diff --git a/app/Http/Controllers/Api/ApiController.php b/app/Http/Controllers/Api/ApiController.php
new file mode 100644
index 0000000..e7b7333
--- /dev/null
+++ b/app/Http/Controllers/Api/ApiController.php
@@ -0,0 +1,208 @@
+<?php
+
+namespace Portal\Http\Controllers\Api;
+
+use Illuminate\Contracts\Pagination\Paginator;
+use Illuminate\Http\Response;
+use League\Fractal\Manager;
+use League\Fractal\Pagination\IlluminatePaginatorAdapter;
+use League\Fractal\Resource\Collection;
+use League\Fractal\Resource\Item;
+use Portal\Http\Controllers\Controller;
+use Portal\Support\DataArraySerializer;
+
+abstract class ApiController extends Controller
+{
+    protected $statusCode = 200;
+
+    protected $fractal;
+
+    /**
+     * @return Manager
+     */
+    protected function fractal()
+    {
+        if ($this->fractal) {
+            return $this->fractal;
+        }
+
+        $fractal = app(Manager::class);
+        $fractal->setRecursionLimit(2);
+        $fractal->setSerializer(new DataArraySerializer);
+
+        if ($includes = request('include')) {
+            $fractal->parseIncludes($includes);
+        }
+
+        return $this->fractal = $fractal;
+    }
+
+    /**
+     * Getter for statusCode
+     *
+     * @return int
+     */
+    public function getStatusCode()
+    {
+        return $this->statusCode;
+    }
+
+    /**
+     * Setter for statusCode
+     *
+     * @param int $statusCode Value to set
+     *
+     * @return self
+     */
+    public function setStatusCode($statusCode)
+    {
+        $this->statusCode = $statusCode;
+        return $this;
+    }
+
+    protected function respondWithItem($item, $callback)
+    {
+        if ($includes = $this->getValidIncludes($callback)) {
+            $item->load($includes);
+        }
+
+        $resource = new Item($item, $callback);
+
+        $rootScope = $this->fractal()->createData($resource);
+
+        return $this->respondWithArray($rootScope->toArray());
+    }
+
+    protected function respondWithCollection($collection, $callback)
+    {
+        if ($includes = $this->getValidIncludes($callback)) {
+            $collection->load($includes);
+        }
+
+        $resource = new Collection($collection, $callback);
+
+        $rootScope = $this->fractal()->createData($resource);
+
+        return $this->respondWithArray($rootScope->toArray());
+    }
+
+    protected function respondWithPagination(Paginator $paginator, $callback)
+    {
+        if ($includes = $this->getValidIncludes($callback)) {
+            $paginator->load($includes);
+        }
+
+        $queryParams = array_diff_key($_GET, array_flip(['page']));
+        $paginator->appends($queryParams);
+
+        $resource = new Collection($paginator, $callback, 'data');
+        $resource->setPaginator(new IlluminatePaginatorAdapter($paginator));
+
+        $rootScope = $this->fractal()->createData($resource);
+
+        return $this->respondWithArray($rootScope->toArray());
+    }
+
+    private function getValidIncludes($callback)
+    {
+        $includes = $this->fractal()->getRequestedIncludes();
+
+        if (! $includes) {
+            return null;
+        }
+
+        return array_intersect(
+            $includes,
+            $callback->getAvailableIncludes()
+        );
+    }
+
+    protected function respondWithSuccess($statusCode = 200)
+    {
+        return $this->setStatusCode($statusCode)
+            ->respondWithArray(['success' => true]);
+    }
+
+    protected function respondWithArray(array $array, array $headers = [])
+    {
+        $response = \Response::json($array, $this->statusCode, $headers);
+
+        $response->header('Content-Type', 'application/json');
+
+        return $response;
+    }
+
+    protected function respondWithError($message)
+    {
+        if ($this->statusCode === 200) {
+            trigger_error(
+                "You better have a really good reason for erroring on a 200...",
+                E_USER_WARNING
+            );
+        }
+
+        return $this->respondWithArray([
+            'error' => $message
+        ]);
+    }
+
+    /**
+     * Generates a Response with a 403 HTTP header and a given message.
+     *
+     * @param string $message
+     * @return Response
+     */
+    public function errorForbidden($message = 'Forbidden')
+    {
+        return $this->setStatusCode(403)
+            ->respondWithError($message);
+    }
+
+    /**
+     * Generates a Response with a 500 HTTP header and a given message.
+     *
+     * @param string $message
+     * @return Response
+     */
+    public function errorInternalError($message = 'Internal Error')
+    {
+        return $this->setStatusCode(500)
+            ->respondWithError($message);
+    }
+
+    /**
+     * Generates a Response with a 404 HTTP header and a given message.
+     *
+     * @param string $message
+     * @return Response
+     */
+    public function errorNotFound($message = 'Resource Not Found')
+    {
+        return $this->setStatusCode(404)
+            ->respondWithError($message);
+    }
+
+    /**
+     * Generates a Response with a 401 HTTP header and a given message.
+     *
+     * @param string $message
+     * @return Response
+     */
+    public function errorUnauthorized($message = 'Unauthorized')
+    {
+        return $this->setStatusCode(401)
+            ->respondWithError($message);
+    }
+
+    /**
+     * Generates a Response with a 400 HTTP header and a given message.
+     *
+     * @param string $message
+     * @return Response
+     */
+    public function errorWrongArgs($message = 'Wrong Arguments')
+    {
+        return $this->setStatusCode(400)
+            ->respondWithError($message);
+    }
+}
diff --git a/app/Http/Controllers/Api/Auth/AuthController.php b/app/Http/Controllers/Api/Auth/AuthController.php
new file mode 100644
index 0000000..1f463aa
--- /dev/null
+++ b/app/Http/Controllers/Api/Auth/AuthController.php
@@ -0,0 +1,59 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Auth;
+
+use JWTAuth;
+use Tymon\JWTAuth\Exceptions\JWTException;
+use Portal\Events\User\LoggedIn;
+use Portal\Events\User\LoggedOut;
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\Auth\LoginRequest;
+
+/**
+ * Class LoginController
+ * @package Portal\Http\Controllers\Api\Auth
+ */
+class AuthController extends ApiController
+{
+    public function __construct()
+    {
+        $this->middleware('guest')->only('login');
+        $this->middleware('auth')->only('logout');
+    }
+
+    /**
+     * Attempt to log the user in and generate unique
+     * JWT token on successful authentication.
+     * @param LoginRequest $request
+     * @return \Illuminate\Http\Response
+     */
+    public function login(LoginRequest $request)
+    {
+        $credentials = $request->only('username', 'password');
+
+        try {
+            if (! $token = JWTAuth::attempt($credentials)) {
+                return $this->errorUnauthorized('Invalid credentials.');
+            }
+        } catch (JWTException $e) {
+            return $this->errorInternalError('Could not create token.');
+        }
+
+        event(new LoggedIn);
+
+        return $this->respondWithArray(compact('token'));
+    }
+
+    /**
+     * Logout user and invalidate token.
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function logout()
+    {
+        event(new LoggedOut);
+
+        auth()->logout();
+
+        return $this->respondWithSuccess();
+    }
+}
diff --git a/app/Http/Controllers/Api/Auth/Password/RemindController.php b/app/Http/Controllers/Api/Auth/Password/RemindController.php
new file mode 100644
index 0000000..859a846
--- /dev/null
+++ b/app/Http/Controllers/Api/Auth/Password/RemindController.php
@@ -0,0 +1,41 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Auth\Password;
+
+use Portal\Events\User\RequestedPasswordResetEmail;
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\Auth\PasswordRemindRequest;
+use Portal\Notifications\ResetPassword;
+use Portal\Repositories\User\UserRepository;
+use Password;
+
+class RemindController extends ApiController
+{
+    /**
+     * Create a new password controller instance.
+     */
+    public function __construct()
+    {
+        $this->middleware('guest');
+    }
+
+    /**
+     * Send a reset link to the given user.
+     *
+     * @param PasswordRemindRequest $request
+     * @param UserRepository $users
+     * @return \Illuminate\Http\Response
+     */
+    public function index(PasswordRemindRequest $request, UserRepository $users)
+    {
+        $user = $users->findByEmail($request->email);
+
+        $token = Password::getRepository()->create($user);
+
+        $user->notify(new ResetPassword($token));
+
+        event(new RequestedPasswordResetEmail($user));
+
+        return $this->respondWithSuccess();
+    }
+}
diff --git a/app/Http/Controllers/Api/Auth/Password/ResetController.php b/app/Http/Controllers/Api/Auth/Password/ResetController.php
new file mode 100644
index 0000000..3799953
--- /dev/null
+++ b/app/Http/Controllers/Api/Auth/Password/ResetController.php
@@ -0,0 +1,58 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Auth\Password;
+
+use Portal\Events\User\ResetedPasswordViaEmail;
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\Auth\PasswordResetRequest;
+use Password;
+
+class ResetController extends ApiController
+{
+    /**
+     * Create a new password controller instance.
+     */
+    public function __construct()
+    {
+        $this->middleware('guest');
+    }
+
+    /**
+     * Reset the given user's password.
+     *
+     * @param PasswordResetRequest $request
+     * @return \Illuminate\Http\Response
+     */
+    public function index(PasswordResetRequest $request)
+    {
+        $credentials = $request->only('email', 'password', 'password_confirmation', 'token');
+
+        $response = Password::reset($credentials, function ($user, $password) {
+            $this->resetPassword($user, $password);
+        });
+
+        switch ($response) {
+            case Password::PASSWORD_RESET:
+                return $this->respondWithSuccess();
+
+            default:
+                return $this->setStatusCode(400)
+                    ->respondWithError(trans($response));
+        }
+    }
+
+    /**
+     * Reset the given user's password.
+     *
+     * @param  \Illuminate\Contracts\Auth\CanResetPassword  $user
+     * @param  string  $password
+     * @return void
+     */
+    protected function resetPassword($user, $password)
+    {
+        $user->password = $password;
+        $user->save();
+
+        event(new ResetedPasswordViaEmail($user));
+    }
+}
diff --git a/app/Http/Controllers/Api/Auth/RegistrationController.php b/app/Http/Controllers/Api/Auth/RegistrationController.php
new file mode 100644
index 0000000..fb76e74
--- /dev/null
+++ b/app/Http/Controllers/Api/Auth/RegistrationController.php
@@ -0,0 +1,87 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Auth;
+
+use Portal\Events\User\Registered;
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\Auth\RegisterRequest;
+use Portal\Repositories\Role\RoleRepository;
+use Portal\Repositories\User\UserRepository;
+use Portal\Support\Enum\UserStatus;
+
+class RegistrationController extends ApiController
+{
+    /**
+     * @var UserRepository
+     */
+    private $users;
+
+    /**
+     * @var RoleRepository
+     */
+    private $roles;
+
+    /**
+     * Create a new authentication controller instance.
+     * @param UserRepository $users
+     * @param RoleRepository $roles
+     */
+    public function __construct(UserRepository $users, RoleRepository $roles)
+    {
+        $this->middleware('registration');
+
+        $this->users = $users;
+        $this->roles = $roles;
+    }
+
+    /**
+     * @param RegisterRequest $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function index(RegisterRequest $request)
+    {
+        // Determine user status. User's status will be set to UNCONFIRMED
+        // if he has to confirm his email or to ACTIVE if email confirmation is not required
+        $status = settings('reg_email_confirmation')
+            ? UserStatus::UNCONFIRMED
+            : UserStatus::ACTIVE;
+
+        $role = $this->roles->findByName('User');
+
+        $user = $this->users->create(array_merge(
+            $request->only('email', 'username', 'password'),
+            ['status' => $status, 'role_id' => $role->id]
+        ));
+
+        event(new Registered($user));
+
+        return $this->setStatusCode(201)
+            ->respondWithArray([
+                'requires_email_confirmation' => !! settings('reg_email_confirmation')
+            ]);
+    }
+
+    /**
+     * Verify email via email confirmation token.
+     * @param $token
+     * @return \Illuminate\Http\Response
+     */
+    public function verifyEmail($token)
+    {
+        if (! settings('reg_email_confirmation')) {
+            return $this->errorNotFound();
+        }
+
+        if ($user = $this->users->findByConfirmationToken($token)) {
+            $this->users->update($user->id, [
+                'status' => UserStatus::ACTIVE,
+                'confirmation_token' => null
+            ]);
+
+            return $this->respondWithSuccess();
+        }
+
+        return $this->setStatusCode(400)
+            ->respondWithError("Invalid confirmation token.");
+    }
+}
diff --git a/app/Http/Controllers/Api/Auth/SocialLoginController.php b/app/Http/Controllers/Api/Auth/SocialLoginController.php
new file mode 100644
index 0000000..ef4c436
--- /dev/null
+++ b/app/Http/Controllers/Api/Auth/SocialLoginController.php
@@ -0,0 +1,64 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Auth;
+
+use Exception;
+use JWTAuth;
+use Socialite;
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\Auth\Social\ApiAuthenticateRequest;
+use Portal\Repositories\User\UserRepository;
+use Portal\Services\Auth\Social\SocialManager;
+
+class SocialLoginController extends ApiController
+{
+    /**
+     * @var UserRepository
+     */
+    private $users;
+
+    /**
+     * @var SocialManager
+     */
+    private $socialManager;
+
+    /**
+     * @param UserRepository $users
+     * @param SocialManager $socialManager
+     */
+    public function __construct(UserRepository $users, SocialManager $socialManager)
+    {
+        $this->users = $users;
+        $this->socialManager = $socialManager;
+    }
+
+    public function index(ApiAuthenticateRequest $request)
+    {
+        try {
+            $socialUser = Socialite::driver($request->network)->userFromToken($request->social_token);
+        } catch (Exception $e) {
+            return $this->errorInternalError("Could not connect to specified social network.");
+        }
+
+        $user = $this->users->findBySocialId(
+            $request->network,
+            $socialUser->getId()
+        );
+
+        if (! $user) {
+            if (! settings('reg_enabled')) {
+                return $this->errorForbidden("Only users who already created an account can log in.");
+            }
+
+            $user = $this->socialManager->associate($socialUser, $request->network);
+        }
+
+        if ($user->isBanned()) {
+            return $this->errorForbidden("Your account is banned by administrators.");
+        }
+
+        return $this->respondWithArray([
+            'token' => JWTAuth::fromUser($user)
+        ]);
+    }
+}
diff --git a/app/Http/Controllers/Api/Authorization/PermissionsController.php b/app/Http/Controllers/Api/Authorization/PermissionsController.php
new file mode 100644
index 0000000..8439892
--- /dev/null
+++ b/app/Http/Controllers/Api/Authorization/PermissionsController.php
@@ -0,0 +1,97 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Authorization;
+
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\Permission\CreatePermissionRequest;
+use Portal\Http\Requests\Permission\RemovePermissionRequest;
+use Portal\Http\Requests\Permission\UpdatePermissionRequest;
+use Portal\Permission;
+use Portal\Repositories\Permission\PermissionRepository;
+use Portal\Transformers\PermissionTransformer;
+
+/**
+ * Class PermissionsController
+ * @package Portal\Http\Controllers\Api\Users
+ */
+class PermissionsController extends ApiController
+{
+    /**
+     * @var PermissionRepository
+     */
+    private $permissions;
+
+    public function __construct(PermissionRepository $permissions)
+    {
+        $this->permissions = $permissions;
+        $this->middleware('auth');
+        $this->middleware('permission:permissions.manage');
+    }
+
+    /**
+     * Get all system permissions.
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function index()
+    {
+        return $this->respondWithCollection(
+            $this->permissions->all(),
+            new PermissionTransformer
+        );
+    }
+
+    /**
+     * Create new permission from request.
+     * @param CreatePermissionRequest $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function store(CreatePermissionRequest $request)
+    {
+        $permission = $this->permissions->create(
+            $request->only(['name', 'display_name', 'description'])
+        );
+
+        return $this->respondWithItem($permission, new PermissionTransformer);
+    }
+
+    /**
+     * Get info about specified permission.
+     * @param Permission $permission
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function show(Permission $permission)
+    {
+        return $this->respondWithItem($permission, new PermissionTransformer);
+    }
+
+    /**
+     * Update specified permission.
+     * @param Permission $permission
+     * @param UpdatePermissionRequest $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function update(Permission $permission, UpdatePermissionRequest $request)
+    {
+        $input = collect($request->all());
+
+        $permission = $this->permissions->update(
+            $permission->id,
+            $input->only(['name', 'display_name', 'description'])->toArray()
+        );
+
+        return $this->respondWithItem($permission, new PermissionTransformer);
+    }
+
+    /**
+     * Remove specified permission from storage.
+     * @param Permission $permission
+     * @param RemovePermissionRequest $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function destroy(Permission $permission, RemovePermissionRequest $request)
+    {
+        $this->permissions->delete($permission->id);
+
+        return $this->respondWithSuccess();
+    }
+}
diff --git a/app/Http/Controllers/Api/Authorization/RolePermissionsController.php b/app/Http/Controllers/Api/Authorization/RolePermissionsController.php
new file mode 100644
index 0000000..a28672c
--- /dev/null
+++ b/app/Http/Controllers/Api/Authorization/RolePermissionsController.php
@@ -0,0 +1,65 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Authorization;
+
+use Cache;
+use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
+use Portal\Events\Role\PermissionsUpdated;
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\Role\CreateRoleRequest;
+use Portal\Http\Requests\Role\RemoveRoleRequest;
+use Portal\Http\Requests\Role\UpdateRolePermissionsRequest;
+use Portal\Http\Requests\Role\UpdateRoleRequest;
+use Portal\Repositories\Role\RoleRepository;
+use Portal\Repositories\User\UserRepository;
+use Portal\Role;
+use Portal\Transformers\PermissionTransformer;
+use Portal\Transformers\RoleTransformer;
+
+/**
+ * Class RolePermissionsController
+ * @package Portal\Http\Controllers\Api
+ */
+class RolePermissionsController extends ApiController
+{
+    /**
+     * @var RoleRepository
+     */
+    private $roles;
+
+    public function __construct(RoleRepository $roles)
+    {
+        $this->roles = $roles;
+        $this->middleware('auth');
+        $this->middleware('permission:permissions.manage');
+    }
+
+    public function show(Role $role)
+    {
+        return $this->respondWithCollection(
+            $role->cachedPermissions(),
+            new PermissionTransformer
+        );
+    }
+
+    /**
+     * Update specified role.
+     * @param Role $role
+     * @param UpdateRolePermissionsRequest $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function update(Role $role, UpdateRolePermissionsRequest $request)
+    {
+        $this->roles->updatePermissions(
+            $role->id,
+            $request->permissions
+        );
+
+        event(new PermissionsUpdated);
+
+        return $this->respondWithCollection(
+            $role->cachedPermissions(),
+            new PermissionTransformer
+        );
+    }
+}
diff --git a/app/Http/Controllers/Api/Authorization/RolesController.php b/app/Http/Controllers/Api/Authorization/RolesController.php
new file mode 100644
index 0000000..0f7c606
--- /dev/null
+++ b/app/Http/Controllers/Api/Authorization/RolesController.php
@@ -0,0 +1,107 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Authorization;
+
+use Cache;
+use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\Role\CreateRoleRequest;
+use Portal\Http\Requests\Role\RemoveRoleRequest;
+use Portal\Http\Requests\Role\UpdateRoleRequest;
+use Portal\Repositories\Role\RoleRepository;
+use Portal\Repositories\User\UserRepository;
+use Portal\Role;
+use Portal\Transformers\RoleTransformer;
+
+/**
+ * Class RolesController
+ * @package Portal\Http\Controllers\Api\Users
+ */
+class RolesController extends ApiController
+{
+    /**
+     * @var RoleRepository
+     */
+    private $roles;
+
+    public function __construct(RoleRepository $roles)
+    {
+        $this->roles = $roles;
+        $this->middleware('auth');
+        $this->middleware('permission:roles.manage');
+    }
+
+    /**
+     * Get all system roles with users count for each role.
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function index()
+    {
+        return $this->respondWithCollection(
+            $this->roles->getAllWithUsersCount(),
+            new RoleTransformer
+        );
+    }
+
+    /**
+     * Create new role from the request.
+     * @param CreateRoleRequest $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function store(CreateRoleRequest $request)
+    {
+        $role = $this->roles->create(
+            $request->only(['name', 'display_name', 'description'])
+        );
+
+        return $this->respondWithItem($role, new RoleTransformer);
+    }
+
+    /**
+     * Return info about specified role.
+     * @param Role $role
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function show(Role $role)
+    {
+        return $this->respondWithItem($role, new RoleTransformer);
+    }
+
+    /**
+     * Update specified role.
+     * @param Role $role
+     * @param UpdateRoleRequest $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function update(Role $role, UpdateRoleRequest $request)
+    {
+        $input = collect($request->all());
+
+        $role = $this->roles->update(
+            $role->id,
+            $input->only(['name', 'display_name', 'description'])->toArray()
+        );
+
+        return $this->respondWithItem($role, new RoleTransformer);
+    }
+
+    /**
+     * Remove specified role (if role is removable).
+     * @param Role $role
+     * @param UserRepository $users
+     * @param RemoveRoleRequest $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function destroy(Role $role, UserRepository $users, RemoveRoleRequest $request)
+    {
+        $userRole = $this->roles->findByName('User');
+
+        $users->switchRolesForUsers($role->id, $userRole->id);
+
+        $this->roles->delete($role->id);
+
+        Cache::flush();
+
+        return $this->respondWithSuccess();
+    }
+}
diff --git a/app/Http/Controllers/Api/CountriesController.php b/app/Http/Controllers/Api/CountriesController.php
new file mode 100644
index 0000000..e264760
--- /dev/null
+++ b/app/Http/Controllers/Api/CountriesController.php
@@ -0,0 +1,36 @@
+<?php
+
+namespace Portal\Http\Controllers\Api;
+
+use Portal\Repositories\Country\CountryRepository;
+use Portal\Transformers\CountryTransformer;
+
+/**
+ * Class CountriesController
+ * @package Portal\Http\Controllers\Api
+ */
+class CountriesController extends ApiController
+{
+    /**
+     * @var CountryRepository
+     */
+    private $countries;
+
+    public function __construct(CountryRepository $countries)
+    {
+        $this->middleware('auth');
+        $this->countries = $countries;
+    }
+
+    /**
+     * Get list of all available countries.
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function index()
+    {
+        return $this->respondWithCollection(
+            $this->countries->all(),
+            new CountryTransformer
+        );
+    }
+}
diff --git a/app/Http/Controllers/Api/Profile/AvatarController.php b/app/Http/Controllers/Api/Profile/AvatarController.php
new file mode 100644
index 0000000..0da9942
--- /dev/null
+++ b/app/Http/Controllers/Api/Profile/AvatarController.php
@@ -0,0 +1,92 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Profile;
+
+use Illuminate\Http\Request;
+use Portal\Events\User\ChangedAvatar;
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\User\UploadAvatarRawRequest;
+use Portal\Repositories\User\UserRepository;
+use Portal\Services\Upload\UserAvatarManager;
+use Portal\Transformers\UserTransformer;
+
+/**
+ * Class DetailsController
+ * @package Portal\Http\Controllers\Api\Profile
+ */
+class AvatarController extends ApiController
+{
+    /**
+     * @var UserRepository
+     */
+    private $users;
+    /**
+     * @var UserAvatarManager
+     */
+    private $avatarManager;
+
+    public function __construct(UserRepository $users, UserAvatarManager $avatarManager)
+    {
+        $this->middleware('auth');
+
+        $this->users = $users;
+        $this->avatarManager = $avatarManager;
+    }
+
+    public function update(UploadAvatarRawRequest $request)
+    {
+        $name = $this->avatarManager->uploadAndCropAvatar(
+            auth()->user(),
+            $request->file('file')
+        );
+
+        $user = $this->users->update(
+            auth()->id(),
+            ['avatar' => $name]
+        );
+
+        event(new ChangedAvatar);
+
+        return $this->respondWithItem($user, new UserTransformer);
+    }
+
+    public function updateExternal(Request $request)
+    {
+        $this->validate($request, [
+            'url' => 'required|url'
+        ]);
+
+        $this->avatarManager->deleteAvatarIfUploaded(
+            auth()->user()
+        );
+
+        $user = $this->users->update(
+            auth()->id(),
+            ['avatar' => $request->url]
+        );
+
+        event(new ChangedAvatar);
+
+        return $this->respondWithItem($user, new UserTransformer);
+    }
+
+    /**
+     * Remove avatar for currently authenticated user and set it to null.
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function destroy()
+    {
+        $user = auth()->user();
+
+        $this->avatarManager->deleteAvatarIfUploaded($user);
+
+        $user = $this->users->update(
+            $user->id,
+            ['avatar' => null]
+        );
+
+        event(new ChangedAvatar);
+
+        return $this->respondWithItem($user, new UserTransformer);
+    }
+}
